planning/urls.py
from django.urls import path
from planning.views import delete_fabrication, fabrication, fabrication_update_status, new_fabrication, pesee
from django.views.generic.base import RedirectView


urlpatterns = [
    path('fabrication/update/status', fabrication_update_status),
    path('fabrication/new', new_fabrication),
    path('fabrication/<int:id>/delete', delete_fabrication),
    path('fabrication', fabrication),
    path('pesee', pesee),
    path('', RedirectView.as_view(url='/fabrication'))
]

planningjournalierfabrication/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("planning.urls"))
]

planning/models.py
from django.db import models


class Formule(models.Model):
    code_vrac = models.CharField(max_length=255, unique=True)
    designation = models.CharField(max_length=255)
    def __str__(self) -> str:
        return 'Formule {} - {}'.format(self.code_vrac, self.designation)

class Machine(models.Model):
    nom = models.CharField(max_length=255, unique=True)
    def __str__(self) -> str:
        return self.nom

# class ParametreMachine(models.Model):
#     nom = models.CharField(max_length=255)
#     valeurs_possibles = models.


class Fabrication(models.Model):

    class Status(models.IntegerChoices):
        NON_DEMARRE = 0
        EC_MOINS = 1
        EC_PLUS = 2
        TERMINE = 3

    date_debut = models.DateTimeField()
    informations = models.TextField()
    status = models.SmallIntegerField(choices=Status.choices, default=Status.NON_DEMARRE)
    def __str__(self) -> str:
        return 'Fabrication {} - {}'.format(self.date_debut, self.informations)


class Pesee(models.Model):

    class Status(models.IntegerChoices):
        NON_DEMARRE = 0
        OF_LANCE = 1
        OT_CREE = 2
        OF_PREPARE = 3
        EN_ATTENTE = 4
        EN_COURS = 5
        TERMINE = 10

    status = models.SmallIntegerField(choices=Status.choices, default=Status.NON_DEMARRE)
    numero_ot = models.BigIntegerField(unique=True, null=True)
    date_debut = models.DateTimeField()


class OrdreFabrication(models.Model):

    class Type(models.IntegerChoices):
        EXISTANT = 0
        FUTURE = 1
    numero_of = models.BigIntegerField(unique=True, null=True)
    numero_lot = models.CharField(max_length=255, blank=True)
    temps_pesee = models.DecimalField(decimal_places=1, max_digits=4, null=True)
    temps_fabrication = models.DecimalField(decimal_places=1, max_digits=4, null=True)
    formule = models.ForeignKey(Formule, on_delete=models.CASCADE)
    machine = models.ForeignKey(Machine, on_delete=models.CASCADE, null=True, blank=True, related_name='ordres_fabrications')
    pesee = models.ForeignKey(Pesee, on_delete=models.CASCADE, null=True, blank=True, related_name='ordre_fabrication')
    fabrication = models.ForeignKey(Fabrication, on_delete=models.SET_NULL, null=True, blank=True, related_name='ordre_fabrication')
    type = models.SmallIntegerField(choices=Type.choices)
    date_theorique = models.DateTimeField(null=True)


class Critere(models.Model):
    code_critere = models.CharField(max_length=255, unique=True)
    consigne = models.TextField()
    lien = models.CharField(max_length=255)


class MatierePremiere(models.Model):
    code_mp = models.CharField(max_length=255, unique=True)
    designation = models.CharField(max_length=255)
    formules = models.ManyToManyField(Formule, related_name='matieres_premieres')
    criteres = models.ManyToManyField(Critere, related_name='matieres_premieres')

planning/forms.py
from collections.abc import Mapping
from typing import Any
from django import forms
from django.forms.utils import ErrorList

from planning.models import Fabrication, Formule, Machine, OrdreFabrication


class FabricationForm(forms.Form):
    date_debut = forms.DateTimeField(label="Date début", widget=forms.DateTimeInput(attrs={'type': 'datetime-local'}))
    ordre_fabrication = forms.ModelChoiceField(OrdreFabrication.objects.filter(fabrication=None), required=False)
    informations = forms.CharField(label="Informations", required=False)
    status = forms.ChoiceField(required=False, initial=0, choices=Fabrication.Status.choices)

    def __init__(self, *args, **kwargs) -> None:
        try:
            machine = kwargs.pop("machine")
        except KeyError:
            machine = None
        super().__init__(*args, **kwargs)
        if (machine):
            self.fields['ordre_fabrication'].queryset = OrdreFabrication.objects.filter(fabrication=None).filter(machine=machine)


class OrdreFabricationFutureForm(forms.Form):
    formule = forms.ModelChoiceField(Formule.objects.all(), required=False)
    machine = forms.ModelChoiceField(Machine.objects.all(), required=False)

planning/views.py
from datetime import datetime, timedelta, timezone
from django.http import HttpResponse
from django.shortcuts import redirect, render
from planning.forms import FabricationForm, OrdreFabricationFutureForm

from planning.models import Fabrication, Machine, OrdreFabrication, Pesee

def fabrication(request):
    week = request.GET.get('week')
    year = request.GET.get('year')
    if (week and year):
        base = datetime.fromisocalendar(int(year), int(week), 1)
    else:
        current_date = datetime.now(timezone.utc)
        base = datetime.fromisocalendar(current_date.year, current_date.isocalendar().week, 1)
    base = base.replace(tzinfo=timezone.utc)
    dates = [base + timedelta(days=x) for x in range(7)]
    base = base - timedelta(days=1)
    base = base.replace(hour = 21, minute = 0, second = 0)
    machines = Machine.objects.all()
    return render(request, 'fabrication.html', {
        'machines': machines,
        'dates': dates,
        'base_date': base,
    })

def fabrication_update_status(request):
    # retrouver la fabrication
    id_fabrication = request.GET.get('idFabrication')
    fabrication = Fabrication.objects.get(id=id_fabrication)
    # retrouver le nouveau le status
    nouveau_status = request.GET.get('status')
    fabrication.status = Fabrication.Status[nouveau_status]
    # mettre à jour la DB
    fabrication.save()
    return redirect('/fabrication')

def new_fabrication(request):
    if (request.method == 'GET'):
        if (request.GET.get('machine_id')):
            machine = Machine.objects.get(id=request.GET.get('machine_id'))
            fabrication_form = FabricationForm(machine=machine)
        else:
            fabrication_form = FabricationForm()
        if (request.GET.get('date_debut')):
            fabrication_form.fields['date_debut'].initial = datetime.fromisoformat(request.GET.get('date_debut'))
        ordre_fabrication_form = OrdreFabricationFutureForm()
        if (request.GET.get('machine_id')):
            ordre_fabrication_form.fields['machine'].initial = Machine.objects.get(id=request.GET.get('machine_id'))
        return render(request, 'new-fabrication.html', {
            'fabrication_form': fabrication_form,
            'ordre_fabrication_form': ordre_fabrication_form
        })
    else:
        fabrication_form = FabricationForm(request.POST)
        ordre_fabrication_form = OrdreFabricationFutureForm(request.POST)
        if (fabrication_form.is_valid() and ordre_fabrication_form.is_valid()):
            of_id = fabrication_form.cleaned_data.pop('ordre_fabrication')
            # creation fabrication
            fabrication = Fabrication(**fabrication_form.cleaned_data)
            fabrication.status = Fabrication.Status.NON_DEMARRE
            fabrication.save()
            # creation pesee
            if (fabrication.date_debut.weekday == 1):
                date_debut_pesee = fabrication.date_debut - timedelta(days=4)
            elif (fabrication.date_debut.weekday == 2):
                date_debut_pesee = fabrication.date_debut - timedelta(days=3)
            else:
                date_debut_pesee = fabrication.date_debut - timedelta(days=2)
            pesee = Pesee(date_debut=date_debut_pesee, status=Pesee.Status.OF_LANCE)
            pesee.save()
            # mise a jour OF
            if (of_id):
                of = OrdreFabrication.objects.get(id=of_id.id)
            else:
                of = OrdreFabrication(**ordre_fabrication_form.cleaned_data)
                of.type = OrdreFabrication.Type.FUTURE
            of.fabrication = fabrication
            of.pesee = pesee
            of.save()
            return redirect('/fabrication')
        return render(request, 'new-fabrication.html', {
            'form': form
        })

def delete_fabrication(request, id):
    fabrication = Fabrication.objects.get(id=id)
    fabrication.delete()
    return redirect('/fabrication')




def pesee(request):
    return HttpResponse('Pesees')

planning/templates/base.html
<!DOCTYPE html>
<html lang="fr">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{% block title %}{% endblock %}</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-T3c6CoIi6uLrA9TneNEoa7RxnatzjcDSCmG1MXxSR1GAsXEV/Dwwykc2MPK8M2HN" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css" integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    {% load static %}
    <link href="{% static 'fabrication.css' %}" rel="stylesheet"></link>
</head>

<body>
    <nav class="navbar bg-body-tertiary">
        <form class="container-fluid justify-content-start">
            <a class="navbar-brand">Planning</a>
            <a href="/fabrication" class="btn btn-sm btn-outline-secondary me-2" type="button">Fabrication</a>
            <a href="/pesee" class="btn btn-sm btn-outline-secondary me-2" type="button">Pesee</a>
            <a href="/admin" class="btn btn-sm btn-outline-secondary" type="button">Admin</a>
        </form>
    </nav>

    {% block content %}{% endblock %}

</body>

</html>

planning/templates/fabrication.html
{% extends "base.html" %}

{% load filters %}

{% block title %}Planning - Fabrication{% endblock  %}

{% block content %}


<a href="/fabrication?{{dates|previous_week}}" class="btn btn-secondary">Semaine précédente</a>
<a href="/fabrication?{{dates|next_week}}" class="btn btn-secondary">Semaine suivante</a>


        <div id="tableau">
            <div id="blank"></div>
            {% for machine in machines %}
                <div class="machine" style="grid-row: {{ forloop.counter|add:2 }} / span 1;">
                    {{ machine.nom }}
                    
                </div>
            {% endfor %}

            {% for machine in machines %}
                <div class="fabrication-placeholder" style="grid-row: {{ forloop.counter|add:2 }} / span 1;">
                    {% for ordre_fabrication in machine.ordres_fabrications.all %}
                    {% with fabrication=ordre_fabrication.fabrication %}
                    {% if fabrication %}
                        <div class="fabrication" style="left: {{ fabrication.date_debut|date_diff:base_date|duration_to_pixel }}px; width: {{ordre_fabrication.temps_fabrication|default:8|duration_to_pixel}}px;">
                            <div class="status">
                                    {% if ordre_fabrication.pesee %}
                                <div 
                                    class="status-pesee"
                                    data-bs-toggle="tooltip" 
                                    data-bs-placement="top"
                                    data-bs-title="Status pesée : {{ordre_fabrication.pesee.status|status_pesee}}">
                                        <div class="done" style="width:{{ordre_fabrication.pesee.status|status_pesee_to_percentage}}%"></div>
                                    <div class="not-done"></div>
                                </div>
                                    {% endif %}
                                <div
                                    class="status-fabrication"
                                    data-bs-toggle="tooltip" 
                                    data-bs-placement="top"
                                    data-bs-title="Status fabrication : {{fabrication.status|status_fabrication}}">
                                    <div class="done" style="width:{{fabrication.status|status_fabrication_to_percentage}}%"></div>
                                    <div class="not-done"></div>
                                </div>
                            </div>
                            <div class="of">OF : {{ ordre_fabrication.numero_of }}</div>
                            <div class="formule">Vrac : {{ ordre_fabrication.formule.code_vrac }}</div>
                            <div class="designation">Des : {{ ordre_fabrication.formule.designation }}</div>
                            <div class="infos">Infos : {{ fabrication.informations }}</div>
                            <div class="dropdown status-picker">
                                <button class="btn btn-outline-secondary btn-sm" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                    <i class="fa-solid fa-list-check fa-fw"></i>
                                </button>
                                <ul class="dropdown-menu">
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=NON_DEMARRE">N</a></li>
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=EC_MOINS">EC-</a></li>
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=EC_PLUS">EC+</a></li>
                                  <li><a class="dropdown-item" href="/fabrication/update/status?idFabrication={{ fabrication.id }}&status=TERMINE">X</a></li>
                                </ul>
                            </div>
                            <div class="dropdown actions">
                                <button class="btn btn-outline-secondary  btn-sm" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                    <i class="fa-solid fa-ellipsis fa-fw"></i>
                                </button>
                                <ul class="dropdown-menu">
                                <li><a class="dropdown-item" href="/fabrication/{{ fabrication.id }}/update">update</a></li>
                                <li><a class="dropdown-item" href="/fabrication/{{ fabrication.id }}/delete">delete</a></li>
                                </ul>
                            </div>
                        </div>
                    {% endif %}
                    {% endwith %}
                    {% endfor %}
            </div>
        {% endfor %}


            {% for date in dates %}
                {% with date_index=forloop.counter0 %}
                <div class="date" style="grid-column: {{ date_index|product:3|add:3 }} / span 3;">
                    <strong>{{ date|date:"D d M y" }}</strong>
                </div>

                <div class="equipe" style="grid-column: {{ date_index|product:3|add:3 }} / span 1;">nuit</div>
                {% for machine in machines %}
                    <div class="custom-border" data-equipe="n" style="grid-column: {{ date_index|product:3|add:2 }} / span 1; grid-row: {{ forloop.counter|add:2 }} / span 1;">
                        <a href="fabrication/new?date_debut={{date|equipe_time:'nuit'|urlencode}}&machine_id={{machine.id}}" type="button" class="btn btn-outline-secondary"><i class="fa-solid fa-circle-plus"></i></a>
                    </div>
                {% endfor %}
                <div class="equipe" style="grid-column: {{ date_index|product:3|add:4 }} / span 1;">matin</div>
                {% for machine in machines %}
                    <div class="custom-border" data-equipe="am" style="grid-column: {{ date_index|product:3|add:3 }} / span 1; grid-row: {{ forloop.counter|add:2 }} / span 1;">
                        <a href="fabrication/new?date_debut={{date|equipe_time:'matin'|urlencode}}&machine_id={{machine.id}}" type="button" class="btn btn-outline-secondary"><i class="fa-solid fa-circle-plus"></i></a>
                    </div>
                {% endfor %}
                <div class="equipe" style="grid-column: {{ date_index|product:3|add:5 }} / span 1;">après-midi</div>
                {% for machine in machines %}
                    <div class="custom-border" data-equipe="pm" style="grid-column: {{ date_index|product:3|add:4 }} / span 1; grid-row: {{ forloop.counter|add:2 }} / span 1;">
                        <a href="fabrication/new?date_debut={{date|equipe_time:'apres-midi'|urlencode}}&machine_id={{machine.id}}" type="button" class="btn btn-outline-secondary"><i class="fa-solid fa-circle-plus"></i></a>
                    </div>
                {% endfor %}
                {% endwith %}
            {% endfor %}
        </div>

        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL" crossorigin="anonymous"></script>
        <script>
            const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
            const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl, { container: 'body' }))
            document
                .querySelectorAll('.fabrication')
                .forEach(f => f.addEventListener('mouseover', e => { console.log("hover !"); e.stopPropagation() }));
        </script>
{% endblock  %}
    

planning/templates/new-fabrication.html
{% extends "base.html" %}

{% block title %}Planning - Nouvelle fabrication{% endblock  %}

{% block content %}

<form action="" method="post" class="d-flex flex-column m-5">
    {% csrf_token %}
    {{ fabrication_form }}
    <div id="ordre_fabrication_form">
        {{ ordre_fabrication_form }}
    </div>
    <div class="d-flex justify-content-evenly mt-5">
        <a href="/fabrication" class="btn btn-secondary">Annuler</a>
        <button class="btn btn-primary">Créer</button>
    </div>
<form>

<script defer>
    document.querySelector("#id_ordre_fabrication")?.addEventListener("change", evt => {
        if (evt.target.value === "") {
            document.querySelector("#ordre_fabrication_form").style.display = 'block'
        } else {
            document.querySelector("#ordre_fabrication_form").style.display = 'none'
        }
    })

</script>

{% endblock  %}